/*
 * Wazuh content manager
 * Copyright (C) 2015, Wazuh Inc.
 * December 12, 2023.
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation.
 */

#ifndef _VULNERABILITY_SCANNER_DEFS_H
#define _VULNERABILITY_SCANNER_DEFS_H

#define VS_WM_NAME         "vulnerability-scanner"
#define WM_VULNSCAN_LOGTAG "wazuh-modulesd:" VS_WM_NAME

#include "threadEventDispatcher.hpp"
#include <functional>
#include <string>

using ReportDispatcher = ThreadEventDispatcher<std::string, std::function<void(std::queue<std::string>&)>>;

namespace Log
{
    inline std::function<void(
        const int, const std::string&, const std::string&, const int, const std::string&, const std::string&, va_list)>
        GLOBAL_LOG_FUNCTION;
};

#endif // _VULNERABILITY_SCANNER_DEFS_H
