/*
 * Wazuh Vulnerability scanner
 * Copyright (C) 2015, Wazuh Inc.
 * March 25, 2023.
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation.
 */

#ifndef _VULNERABILITY_SCANNER_H
#define _VULNERABILITY_SCANNER_H

// Define EXPORTED for any platform

#if __GNUC__ >= 4
#define EXPORTED __attribute__((visibility("default")))
#else
#define EXPORTED
#endif

#include <external/cJSON/cJSON.h>

#ifdef __cplusplus
extern "C"
{
#endif

#include "logging_helper.h"
#include "commonDefs.h"

    EXPORTED void vulnerability_scanner_start(full_log_fnc_t callbackLog, const cJSON* configuration);

    EXPORTED void vulnerability_scanner_stop();

    EXPORTED bool vulnerability_scanner_policy_change_event(const char* data);

#ifdef __cplusplus
}
#endif

typedef void (*vulnerability_scanner_start_func)(full_log_fnc_t callbackLog, const cJSON* configuration);

typedef void (*vulnerability_scanner_stop_func)();

typedef bool (*vulnerability_scanner_policy_change_func)(const char* data);

#endif // _VULNERABILITY_SCANNER_H
