/*
 * Wazuh Vulnerability Scanner - Unit Tests
 * Copyright (C) 2015, Wazuh Inc.
 * September 21, 2023.
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation.
 */

#ifndef _EVENT_INSERT_INVENTORY_TEST_HPP
#define _EVENT_INSERT_INVENTORY_TEST_HPP

#include "rocksDBWrapper.hpp"
#include "gtest/gtest.h"

/**
 * @brief Runs unit tests for EventInsertInventory
 */
class EventInsertInventoryTest : public ::testing::Test
{
protected:
    // LCOV_EXCL_START
    /**
     * @brief RocksDB inventory database instance.
     *
     */
    std::unique_ptr<Utils::RocksDBWrapper> m_inventoryDatabase;

    EventInsertInventoryTest() = default;
    ~EventInsertInventoryTest() override = default;

    /**
     * @brief Set up for every test.
     *
     */
    void SetUp() override;

    /**
     * @brief Tear down for every test.
     *
     */
    void TearDown() override;
    // LCOV_EXCL_STOP
};

#endif // _EVENT_INSERT_INVENTORY_TEST_HPP
