/*
 * Wazuh PolicyManager
 * Copyright (C) 2015, Wazuh Inc.
 * September 8, 2023.
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation.
 */
#ifndef _POLICY_MANAGER_TEST_H
#define _POLICY_MANAGER_TEST_H
#include "../../src/policyManager/policyManager.hpp"
#include "gmock/gmock.h"
#include "gtest/gtest.h"
#include <memory>

/**
 * @brief This test class contains unit tests for the PolicyManager module.
 */
class PolicyManagerTest : public ::testing::Test
{
protected:
    /// \private
    PolicyManagerTest() = default;
    /// \private
    virtual ~PolicyManagerTest() = default;

    /// \private
    void SetUp() override;
    /// \private
    void TearDown() override;

    /// \private
    std::unique_ptr<PolicyManager> m_policyManager;
};

#endif //_POLICY_MANAGER_TEST_H
